"use strict";

require("core-js/modules/es.symbol");

require("core-js/modules/es.symbol.description");

require("core-js/modules/es.symbol.iterator");

require("core-js/modules/es.array.filter");

require("core-js/modules/es.array.for-each");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.function.name");

require("core-js/modules/es.object.assign");

require("core-js/modules/es.object.get-own-property-descriptor");

require("core-js/modules/es.object.get-own-property-descriptors");

require("core-js/modules/es.object.get-prototype-of");

require("core-js/modules/es.object.keys");

require("core-js/modules/es.object.set-prototype-of");

require("core-js/modules/es.object.to-string");

require("core-js/modules/es.reflect.construct");

require("core-js/modules/es.regexp.to-string");

require("core-js/modules/es.string.iterator");

require("core-js/modules/web.dom-collections.for-each");

require("core-js/modules/web.dom-collections.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = ReactLoader;

var _react = _interopRequireDefault(require("react"));

var _deepEql = _interopRequireDefault(require("deep-eql"));

var _isPromise = _interopRequireDefault(require("is-promise"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _construct(Parent, args, Class) { if (_isNativeReflectConstruct()) { _construct = Reflect.construct; } else { _construct = function _construct(Parent, args, Class) { var a = [null]; a.push.apply(a, args); var Constructor = Function.bind.apply(Parent, a); var instance = new Constructor(); if (Class) _setPrototypeOf(instance, Class.prototype); return instance; }; } return _construct.apply(null, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var STATUS_FETCHING = 0;
var STATUS_LOADED = 1;
var STATUS_ERROR = -1;
var NODE_ENV = undefined || 'production';
var debug = NODE_ENV === 'development' ? console.log : function () {};
debug('Environment:', NODE_ENV);

function ReactLoader() {
  var _options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var options = Object.assign({
    load: null,
    resultProp: 'data',
    errorProp: 'error',
    errorComponent: function errorComponent() {
      return /*#__PURE__*/_react.default.createElement("div", null, "Impossible to fetch the data requested.");
    },
    loadingComponent: function loadingComponent() {
      return /*#__PURE__*/_react.default.createElement("div", null, "Loading...");
    },
    shouldComponentReload: function shouldComponentReload(props, nextProps) {
      return !(0, _deepEql.default)(props, nextProps);
    },
    componentWillUnmount: function componentWillUnmount() {}
  }, _options);

  if (!options.load) {
    throw new Error('ReactLoader : No load() defined. Cannot create');
  }

  if (typeof options.load !== 'function') {
    throw new Error('ReactLoader : load must be a function returning a Promise. Cannot create');
  }

  var ErrorComponent = options.errorComponent;
  var LoadingComponent = options.loadingComponent;
  var load = options.load;
  var _componentWillUnmount = options.componentWillUnmount;
  var shouldComponentReload = options.shouldComponentReload;
  var resultProp = options.resultProp;
  var errorProp = options.errorProp;

  var _Loader = /*#__PURE__*/function (_React$Component) {
    _inherits(_Loader, _React$Component);

    var _super = _createSuper(_Loader);

    function _Loader(props) {
      var _this;

      _classCallCheck(this, _Loader);

      _this = _super.call(this, props);
      _this.state = {
        status: STATUS_FETCHING
      };
      return _this;
    }

    _createClass(_Loader, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        this.doLoad();
      } //eslint-disable-next-line no-unused-vars

    }, {
      key: "componentDidUpdate",
      value: function componentDidUpdate(prevProps, prevState, snapshot) {
        if (shouldComponentReload(prevProps, this.props)) {
          this.doLoad();
        }
      }
    }, {
      key: "doLoad",
      value: function doLoad() {
        var _this2 = this;

        debug('doLoad', this.props);
        this.setState({
          status: STATUS_FETCHING
        });
        var prom = load(this.props);

        if (!(0, _isPromise.default)(prom)) {
          throw new TypeError('ReactLoader : load(props) must return a Promise/A+ compliant object');
        }

        prom.then(function (data) {
          debug('Loaded !', _this2.props);

          _this2.setState({
            status: STATUS_LOADED,
            data: data
          });

          return data;
        }).catch(function (e) {
          debug('Error !', _this2.props);

          _this2.setState({
            status: STATUS_ERROR,
            error: e
          });
        });
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        debug('unmount !', this.props);

        _componentWillUnmount(this.props);
      }
    }, {
      key: "render",
      value: function render() {
        debug('render');
        var props = this.props;

        if (this.state.status === STATUS_ERROR) {
          var forwardProps = Object.assign({}, props);
          forwardProps[errorProp] = this.state.error;
          return /*#__PURE__*/_react.default.createElement(ErrorComponent, forwardProps);
        } else if (this.state.status === STATUS_LOADED) {
          return this.renderComponent();
        } else {
          return /*#__PURE__*/_react.default.createElement(LoadingComponent, props);
        }
      } //eslint-disable-next-line no-unused-vars

    }, {
      key: "shouldComponentUpdate",
      value: function shouldComponentUpdate(nextProps, nextState, nextContext) {
        return !(0, _deepEql.default)(this.props, nextProps) || !(0, _deepEql.default)(this.state, nextState);
      }
    }]);

    return _Loader;
  }(_react.default.Component);

  var outFn = function outFn(Component) {
    if (_typeof(Component) === 'object' && Component.kind === 'class') {
      return _objectSpread(_objectSpread({}, Component), {}, {
        finisher: function finisher(Class) {
          return function () {
            for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
              args[_key] = arguments[_key];
            }

            return _construct(outFn(Class), args);
          };
        }
      });
    } else {
      var Loader = /*#__PURE__*/function (_Loader2) {
        _inherits(Loader, _Loader2);

        var _super2 = _createSuper(Loader);

        function Loader() {
          _classCallCheck(this, Loader);

          return _super2.apply(this, arguments);
        }

        _createClass(Loader, [{
          key: "renderComponent",
          value: function renderComponent() {
            var forwardProps = Object.assign({}, this.props);
            forwardProps[resultProp] = this.state.data;
            return /*#__PURE__*/_react.default.createElement(Component, forwardProps);
          }
        }]);

        return Loader;
      }(_Loader);

      Loader.displayName = "ReactLoader(".concat(Component.displayName || Component.name, ")");
      Loader.propTypes = Component.propTypes;
      return Loader;
    }
  };

  return outFn;
}